diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-typeinfo.h
--- a/libinterp/parse-tree/jit-typeinfo.h	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-typeinfo.h	Fri May 31 16:09:22 2019 -0500
@@ -143,7 +143,7 @@
 
     typedef llvm::Value *(*convert_fn) (llvm::IRBuilderD&, llvm::Value *);
 
-    jit_type (const std::string& aname, jit_type *aparent, llvm::Type *allvm_type,
+    jit_type (std::string aname, jit_type *aparent, llvm::Type *allvm_type,
               bool askip_paren, int aid);
 
     // a user readable type name
@@ -213,13 +213,14 @@
     size_t m_depth;
     bool m_skip_paren;
 
-    bool m_sret[jit_convention::length];
-    bool m_pointer_arg[jit_convention::length];
+    std::array<bool, jit_convention::length> m_sret;
+    std::array<bool, jit_convention::length> m_pointer_arg;
 
-    convert_fn m_pack[jit_convention::length];
-    convert_fn m_unpack[jit_convention::length];
+    std::array<convert_fn, jit_convention::length> m_pack;
+    std::array<convert_fn, jit_convention::length> m_unpack;
 
-    llvm::Type *m_packed_type[jit_convention::length];
+    std::array<llvm::Type *, jit_convention::length> m_packed_type;
+
   };
 
   // seperate print function to allow easy printing if type is null
@@ -246,20 +247,22 @@
 
     jit_function (const jit_module *amodule, jit_convention::type acall_conv,
                   const llvm::Twine& aname, jit_type *aresult,
-                  const std::vector<jit_type *>& aargs);
+                  std::vector<jit_type *> aargs);
 
     // Use an existing function, but change the argument types.  The new argument
     // types must behave the same for the current calling convention.
     jit_function (const jit_function& fn, jit_type *aresult,
-                  const std::vector<jit_type *>& aargs);
+                  std::vector<jit_type *> aargs);
 
-    jit_function (const jit_function& fn);
+    jit_function (const jit_function& fn) = default;
 
-    // erase the interal LLVM function (if it exists).  Will become invalid.
+    // erase the internal LLVM function (if it exists).  Will become invalid.
     void erase (void);
 
     bool valid (void) const { return m_llvm_function; }
 
+    llvm::FunctionType* type (void) const;
+
     std::string name (void) const;
 
     llvm::BasicBlock * new_block (const std::string& aname = "body",
@@ -309,6 +312,50 @@
       return call (builder, in_args, other_args...);
     }
 
+    llvm::Value * call (const jit_module& amodule,
+                        llvm::IRBuilderD& builder,
+                        const arg_vec &in_args = arg_vec ()) const;
+
+    llvm::Value * call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                        const std::vector<jit_value *>& in_args) const;
+
+    template <typename ...Args>
+    llvm::Value * call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                        arg_vec& in_args, llvm::Value * arg1,
+                        Args... other_args) const
+    {
+      in_args.push_back (arg1);
+      return call (amodule, builder, in_args, other_args...);
+    }
+
+    template <typename T, typename ...Args>
+    llvm::Value * call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                        arg_vec& in_args, T * arg1, Args... other_args) const
+    {
+      in_args.push_back (arg1->to_llvm ());
+      return call (amodule, builder, in_args, other_args...);
+    }
+
+    template <typename ...Args>
+    llvm::Value * call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                        llvm::Value * arg1, Args... other_args) const
+    {
+      arg_vec in_args;
+      in_args.reserve (1 + sizeof... (other_args));
+      in_args.push_back (arg1);
+      return call (amodule, builder, in_args, other_args...);
+    }
+
+    template <typename T, typename ...Args>
+    llvm::Value * call (const jit_module& amodule, llvm::IRBuilderD& builder,
+                        T * arg1, Args... other_args) const
+    {
+      arg_vec in_args;
+      in_args.reserve (1 + sizeof... (other_args));
+      in_args.push_back (arg1->to_llvm ());
+      return call (amodule, builder, in_args, other_args...);
+    }
+
     llvm::Value * argument (llvm::IRBuilderD& builder, size_t idx) const;
 
     void do_return (llvm::IRBuilderD& builder, llvm::Value *rval = nullptr,
@@ -748,6 +795,12 @@
     static llvm::Value *unpack_complex (llvm::IRBuilderD& bld,
                                         llvm::Value *result);
 
+    // Print all function locations in the base module.
+    static void print_all_flocs ();
+
+    // Print all functions in the base module.
+    static void print_all_functions ();
+
   private:
 
     jit_type * do_type_of (const octave_value& ov) const;
@@ -830,6 +883,14 @@
                            name, ret, args);
     }
 
+    jit_function create_internal (jit_module *module, const llvm::Twine& name,
+                                  jit_type *ret, const signature_vec& args
+                                  = signature_vec ()) const
+    {
+      return jit_function (module, jit_convention::internal,
+                           name, ret, args);
+    }
+
     template <typename ...Args>
     jit_function create_internal (const llvm::Twine& name, jit_type *ret,
                                   signature_vec& args,
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-util.cc
--- a/libinterp/parse-tree/jit-util.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-util.cc	Fri May 31 16:09:22 2019 -0500
@@ -22,10 +22,6 @@
 
 // Author: Max Brister <max@2bass.com>
 
-// defines required by llvm
-#define __STDC_LIMIT_MACROS
-#define __STDC_CONSTANT_MACROS
-
 #if defined (HAVE_CONFIG_H)
 #  include "config.h"
 #endif
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/jit-util.h
--- a/libinterp/parse-tree/jit-util.h	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/jit-util.h	Fri May 31 16:09:22 2019 -0500
@@ -54,13 +54,12 @@
   class Twine;
   class GlobalValue;
   class GlobalVariable;
-  class TerminatorInst;
   class PHINode;
   class TargetMachine;
 
   class ConstantFolder;
 
-#if defined  LLVM_IRBUILDER_HAS_TWO_TEMPLATE_ARGS
+#if defined (LLVM_IRBUILDER_HAS_TWO_TEMPLATE_ARGS)
 
   class IRBuilderDefaultInserter;
 
@@ -227,11 +226,11 @@
   };
 
   // Use like: isa<jit_phi> (value)
-  // basically just a short cut type typing dyanmic_cast.
+  // basically just a short cut type typing dynamic_cast.
   template <typename T, typename U>
   bool isa (U *value)
   {
-    return dynamic_cast<T *> (value);
+    return dynamic_cast<T *> (value) != nullptr;
   }
 
 }
diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/pt-eval.cc
--- a/libinterp/parse-tree/pt-eval.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/pt-eval.cc	Fri May 31 16:09:22 2019 -0500
@@ -2178,7 +2178,7 @@
     octave_value rhs = evaluate (expr);
 
 #if defined (HAVE_LLVM)
-    if (tree_jit::execute (cmd, rhs))
+    if (tree_jit::execute (*this, cmd, rhs))
       return;
 #endif
 
@@ -2465,7 +2465,7 @@
 
 #if defined (HAVE_LLVM)
     if (user_function.is_special_expr ()
-        && tree_jit::execute (user_function, args, retval))
+        && tree_jit::execute (*this, user_function, args, retval))
       return retval;
 #endif
 
@@ -4018,7 +4018,7 @@
       }
 
 #if defined (HAVE_LLVM)
-    if (tree_jit::execute (cmd))
+    if (tree_jit::execute (*this, cmd))
       return;
 #endif
 
@@ -4068,7 +4068,7 @@
       }
 
 #if defined (HAVE_LLVM)
-    if (tree_jit::execute (cmd))
+    if (tree_jit::execute (*this, cmd))
       return;
 #endif
 
